{{
    config(
        schema='DW_SALES',
        materialized='incremental',
        unique_key='CUSTOMER_SK'
    )
}}

WITH STG_CUSTOMER AS
(SELECT DISTINCT C_CUSTKEY as CUSTOMER_ID, 
    C_NAME as CUSTOMER_NAME, 
    C_CUSTKEY as AUDIT_ROW_NATURAL_KEY,
    MD5(C_NAME) as AUDIT_UPDATE_CHECKSUM
 FROM {{ source('TPCH_SF1', 'CUSTOMER') }}
 ORDER BY 1)

 SELECT NVL(D.CUSTOMER_SK,DW_SALES.DIM_CUSTOMER_SEQ.nextval) CUSTOMER_SK, 
    C.CUSTOMER_ID, 
    C.CUSTOMER_NAME, 
    C.AUDIT_ROW_NATURAL_KEY,
    C.AUDIT_UPDATE_CHECKSUM,
    NVL(D.AUDIT_CREATION_DATE_TIME,SYSDATE()) as AUDIT_CREATION_DATE_TIME,
    SYSDATE() as AUDIT_UPDATE_DATE_TIME,
    '{{ invocation_id }}' AS AUDIT_GUID  
 FROM STG_CUSTOMER C
  LEFT JOIN DW_SALES.DIM_CUSTOMER D ON (C.AUDIT_ROW_NATURAL_KEY = D.AUDIT_ROW_NATURAL_KEY)
 WHERE C.AUDIT_UPDATE_CHECKSUM <> D.AUDIT_UPDATE_CHECKSUM OR D.AUDIT_UPDATE_CHECKSUM IS NULL

